﻿var
    idUser: integer = -1;
    isReg: boolean = True;






procedure frmAbout_lbLink_OnClick (Sender: TObject);
begin
    OpenURL('http://myvisualdatabase.com/ru/');
end;

procedure Form1_bClientNew_OnClick (Sender: TObject; var Cancel: boolean);
begin
    if not isReg then
    begin
        If SQLExecute('SELECT COUNT(*) FROM Client') > 4 then if not isReg then frmReg.ShowModal;
        Cancel := True;
    end;
end;

procedure frmReg_bKey_OnClick (Sender: TObject; var Cancel: boolean);
begin
    if ValidKey(frmReg.edKey.Text) then
    begin
        isReg := True;
        WriteKey(frmReg.edKey.Text);
        ShowMessage('Спасибо за регистрацию программы и за поддержку нашего проекта.');
        frmReg.Close;
    end;
end;

procedure frmReg_bReg_OnClick (Sender: TObject; var Cancel: boolean);
begin
    OpenURL('http://myvisualdatabase.com/purchasecrm_ru.html');
end;

procedure CheckReg;
var
  ini: TIniFile;
begin
    //ini := TIniFile.Create(Application.SettingsFile);
    //isReg := ValidKey( ini.ReadString('Key', 'Key', '') );
    //ini.Free;
end;

procedure WriteKey(sKey: string);                    
var
  ini: TIniFile;
begin
    ini := TIniFile.Create(Application.SettingsFile);
    ini.WriteString('Key', 'Key', sKey);
    ini.Free;
end;

function ValidKey(sKey: string): boolean;
var
    i1, i2, i3, i4: integer;
begin
    if Length(sKey)=20 then
    begin
        if (ValidInt(sKey[5])) and (ValidInt(sKey[10])) and (ValidInt(sKey[15])) and (ValidInt(sKey[20])) then
        begin
            i1 := StrToInt(sKey[5]);
            i2 := StrToInt(sKey[10]);
            i3 := StrToInt(sKey[15]);
            i4 := StrToInt(sKey[20]);

            if i1+i2+i3+i4 = 20 then result := True;
        end;                                                                                      
    end;
end;

procedure frmUserAdd_bSave_OnClick (Sender: TObject; var Cancel: boolean);
begin
    if frmUserAdd.chbAdmin.Checked then frmUserAdd.chbDisabled.Checked := False;
end;

procedure frmClient_bAddCountry_OnAfterClick (Sender: TObject);
begin
    frmClient.cbCountry.dbItemID := Last_Insert_id;
    frmClient.cbCountry.DoOnChange;
end;

procedure frmClient_bAddCity_OnAfterClick (Sender: TObject);
begin
    frmClient.cbCountry.DoOnChange;
    frmClient.cbCity.dbItemID := Last_Insert_id;
end;

procedure PrintContract(idContract: integer);
var
    Word: TWord;
    sName, sAddress, sPhone, sEmail: string;
    sWordTemp: string;
    sWordFinal: string;


    ResultsSeller: TDataSet;
    ResultsClient: TDataSet;
begin


    SQLQuery('SELECT Name, AddressLegal, INN, KPP, OGRN, BankAccount, BankName, KorrAccount, BIC, Phone, Fax, Director, Accountant, City FROM Seller WHERE id=1', ResultsSeller);
    SQLQuery('SELECT Contract.record_count, Contract.Amount, Client.ClientName, Client.INN, Client.BankRequisites, Client.AddressLegal, Client.Director, Client.Phone FROM Contract LEFT OUTER JOIN Client ON Contract.id_Client=Client.id WHERE Contract.id='+IntToStr(idContract), ResultsClient);

    sWordTemp  := ExtractFilePath(Application.ExeName)+'\WordTemplate\contract_template.doc';
    sWordFinal := GetEnvironmentVariable('TEMP') + '\contract_print_'+FormatDateTime('ddmmyyy_hhnnss', now)+'.doc';
    CopyFile(sWordTemp, sWordFinal);

    Word := TWord.Create;
    Word.Visible := True;
    Word.Open(sWordFinal);

    Word.FindAndReplace('{ContractNumber}', ResultsClient.FieldByName('record_count').AsString );
    Word.FindAndReplace('{DateNow}',  DateToStr(now) );
    Word.FindAndReplace('{ClientName}',  ResultsClient.FieldByName('ClientName').AsString );
    Word.FindAndReplace('{ClientINN}',  ResultsClient.FieldByName('INN').AsString );
    Word.FindAndReplace('{ClientDirector}',  ResultsClient.FieldByName('Director').AsString );
    Word.FindAndReplace('{ClientAddressLegal}',  ResultsClient.FieldByName('AddressLegal').AsString );
    Word.FindAndReplace('{ClientPhone}',  ResultsClient.FieldByName('Phone').AsString );
    Word.FindAndReplace('{ClientBankRequisites}',  ResultsClient.FieldByName('BankRequisites').AsString );
    Word.FindAndReplace('{Amount}',  FormatFloat('#,##0.00', ResultsClient.FieldByName('Amount').AsFloat) );
    Word.FindAndReplace('{AmountWords}',  ToWordsRu(ResultsClient.FieldByName('Amount').AsFloat) );

    Word.FindAndReplace('{City}',  ResultsSeller.FieldByName('City').AsString );
    Word.FindAndReplace('{SellerName}',  ResultsSeller.FieldByName('Name').AsString );
    Word.FindAndReplace('{SellerPhone}',  ResultsSeller.FieldByName('Phone').AsString );
    Word.FindAndReplace('{SellerDirector}',  ResultsSeller.FieldByName('Director').AsString );
    Word.FindAndReplace('{SellerAddressLegal}',  ResultsSeller.FieldByName('AddressLegal').AsString );
    Word.FindAndReplace('{SellerINN}',  ResultsSeller.FieldByName('INN').AsString );
    Word.FindAndReplace('{SellerKPP}',  ResultsSeller.FieldByName('KPP').AsString );
    Word.FindAndReplace('{SellerBankAccount}',  ResultsSeller.FieldByName('BankAccount').AsString );
    Word.FindAndReplace('{SellerBankName}',  ResultsSeller.FieldByName('BankName').AsString );
    Word.FindAndReplace('{SellerKorrAccount}',  ResultsSeller.FieldByName('KorrAccount').AsString );
    Word.FindAndReplace('{SellerBIC}',  ResultsSeller.FieldByName('BIC').AsString );


    Word.Free;
end;

procedure Form1_bPrintContractW_OnClick (Sender: TObject; var Cancel: boolean);
begin
   if Form1.gridContract.dbItemID = -1 then ShowMessage('Выберите контракт для печати') else
       PrintContract(Form1.gridContract.dbItemID);
end;

procedure frmClient_bPrintContractW_OnClick (Sender: TObject; var Cancel: boolean);
begin
   if frmClient.gridContract.dbItemID = -1 then ShowMessage('Выберите контракт для печати') else
       PrintContract(frmClient.gridContract.dbItemID);
end;


procedure Form1_bPrintContract_OnClick (Sender: TObject; var Cancel: boolean);
var
    Results: TDataSet;
begin
    SQLQuery('SELECT Name, AddressLegal, INN, KPP, OGRN, BankAccount, BankName, KorrAccount, BIC, Phone, Fax, Director, Accountant FROM Seller WHERE id=1', Results);

    if not Results.isEmpty then
    begin
        frmLogin.frxReport.Variables.Clear;
        frmLogin.frxReport.Variables[' ' + 'Seller'] := Null;
        frmLogin.frxReport.Variables['Name'] := ''''+ Results.FieldByName('Name').AsString +'''';
        frmLogin.frxReport.Variables['AddressLegal'] := ''''+ Results.FieldByName('AddressLegal').AsString +'''';
        frmLogin.frxReport.Variables['INN'] := ''''+ Results.FieldByName('INN').AsString +'''';
        frmLogin.frxReport.Variables['KPP'] := ''''+ Results.FieldByName('KPP').AsString +'''';
        frmLogin.frxReport.Variables['OGRN'] := ''''+ Results.FieldByName('OGRN').AsString +'''';
        frmLogin.frxReport.Variables['BankAccount'] := ''''+ Results.FieldByName('BankAccount').AsString +'''';
        frmLogin.frxReport.Variables['BankName'] := ''''+ Results.FieldByName('BankName').AsString +'''';
        frmLogin.frxReport.Variables['KorrAccount'] := ''''+ Results.FieldByName('KorrAccount').AsString +'''';
        frmLogin.frxReport.Variables['BIC'] := ''''+ Results.FieldByName('BIC').AsString +'''';
        frmLogin.frxReport.Variables['Phone'] := ''''+ Results.FieldByName('Phone').AsString +'''';
        frmLogin.frxReport.Variables['Fax'] := ''''+ Results.FieldByName('Fax').AsString +'''';
        frmLogin.frxReport.Variables['Director'] := ''''+ Results.FieldByName('Director').AsString +'''';
        frmLogin.frxReport.Variables['Accountant'] := ''''+ Results.FieldByName('Accountant').AsString +'''';
    end;
end;


procedure frmInvoice_Button4_OnClick (Sender: TObject; var Cancel: boolean);
var
    Results: TDataSet;
begin
    SQLQuery('SELECT Name, AddressLegal, INN, KPP, OGRN, BankAccount, BankName, KorrAccount, BIC, Phone, Fax, Director, Accountant FROM Seller WHERE id=1', Results);

    if not Results.isEmpty then
    begin
        frmLogin.frxReport.Variables.Clear;
        frmLogin.frxReport.Variables[' ' + 'Seller'] := Null;
        frmLogin.frxReport.Variables['Name'] := ''''+ Results.FieldByName('Name').AsString +'''';
        frmLogin.frxReport.Variables['AddressLegal'] := ''''+ Results.FieldByName('AddressLegal').AsString +'''';
        frmLogin.frxReport.Variables['INN'] := ''''+ Results.FieldByName('INN').AsString +'''';
        frmLogin.frxReport.Variables['KPP'] := ''''+ Results.FieldByName('KPP').AsString +'''';
        frmLogin.frxReport.Variables['OGRN'] := ''''+ Results.FieldByName('OGRN').AsString +'''';
        frmLogin.frxReport.Variables['BankAccount'] := ''''+ Results.FieldByName('BankAccount').AsString +'''';
        frmLogin.frxReport.Variables['BankName'] := ''''+ Results.FieldByName('BankName').AsString +'''';
        frmLogin.frxReport.Variables['KorrAccount'] := ''''+ Results.FieldByName('KorrAccount').AsString +'''';
        frmLogin.frxReport.Variables['BIC'] := ''''+ Results.FieldByName('BIC').AsString +'''';
        frmLogin.frxReport.Variables['Phone'] := ''''+ Results.FieldByName('Phone').AsString +'''';
        frmLogin.frxReport.Variables['Fax'] := ''''+ Results.FieldByName('Fax').AsString +'''';
        frmLogin.frxReport.Variables['Director'] := ''''+ Results.FieldByName('Director').AsString +'''';
        frmLogin.frxReport.Variables['Accountant'] := ''''+ Results.FieldByName('Accountant').AsString +'''';
    end;
end;

procedure frmDict_OnShow (Sender: TObject; Action: string);
begin
    ShowRecord(frmDict, 'Seller', 1);
end;

procedure ApplyPrivilege(id: integer);
var
    Results: TDataSet;
begin
    SQLQuery('SELECT privAdmin, privClient, privContact, privEvent, privDeal, privContract, privInvoice, privPayment, privOrder, privOrderProduct, privProducts, privDict, privCanDelete FROM User WHERE id='+ IntToStr(id), Results);
    if not Results.isEmpty then
    begin
        if Results.FieldByName('privAdmin').AsInteger = 1 then exit; // можем все, выходим
        Form1.bUsers.Enabled := False;

        if Results.FieldByName('privClient').AsInteger <> 1 then Form1.tabClient.TabVisible := False;

        if Results.FieldByName('privContact').AsInteger <> 1 then
        begin
            Form1.tabContact.TabVisible := False;
            frmClient.tabContact.TabVisible := False;
        end;
        if Results.FieldByName('privEvent').AsInteger <> 1 then
        begin
            Form1.tabEvent.TabVisible := False;
            frmClient.tabEvent.TabVisible := False;
        end;
        if Results.FieldByName('privDeal').AsInteger <> 1 then
        begin
            Form1.tabDeal.TabVisible := False;
            frmClient.tabDeal.TabVisible := False;
        end;
        if Results.FieldByName('privContract').AsInteger <> 1 then
        begin
            Form1.tabContract.TabVisible := False;
            frmClient.tabContract.TabVisible := False;

            frmDeal.gridContract.dbGeneralTable := '';
            frmDeal.gridContract.Caption := 'Отключено';
            frmDeal.bContractNew.Enabled := False;
            frmDeal.bContractEdit.Enabled := False;
            frmDeal.bContractDelete.Enabled := False;
        end;
        if Results.FieldByName('privInvoice').AsInteger <> 1 then
        begin
            Form1.tabInvoice.TabVisible := False;
            frmClient.tabInvoice.TabVisible := False;
            frmContract.tabInvoice.TabVisible := False;
        end;
        if Results.FieldByName('privPayment').AsInteger <> 1 then
        begin
            Form1.tabPayment.TabVisible := False;
            frmClient.tabPayment.TabVisible := False;
            frmContract.tabPayment.TabVisible := False;

            frmInvoice.gridPayments.dbGeneralTable := '';
            frmInvoice.gridPayments.Caption := 'Отключено';
        end;
        if Results.FieldByName('privOrder').AsInteger <> 1 then
        begin
            Form1.tabOrder.TabVisible := False;
            frmClient.tabOrder.TabVisible := False;
        end;
        if Results.FieldByName('privOrderProduct').AsInteger <> 1 then
        begin
            Form1.tabOrderProduct.TabVisible := False;
            frmClient.tabOrderProduct.TabVisible := False;
            frmOrder.gridOrderProduct.dbGeneralTable := '';
            frmOrder.gridOrderProduct.Caption := 'Отключено';
        end;
        if Results.FieldByName('privProducts').AsInteger <> 1 then
        begin
            Form1.tabProducts.TabVisible := False;
        end;

        if Results.FieldByName('privDict').AsInteger <> 1 then Form1.bDict.Visible := False;

        if Results.FieldByName('privCanDelete').AsInteger <> 1 then
        begin
            Form1.bClientDelete.Enabled := False;
            Form1.bContactDelete.Enabled := False;
            Form1.bEventDelete.Enabled := False;
            Form1.bDealDelete.Enabled := False;
            Form1.bContractDelete.Enabled := False;
            Form1.bInvoiceDelete.Enabled := False;
            Form1.bPaymentDelete.Enabled := False;
            Form1.bOrderDelete.Enabled := False;
            Form1.bOrderProductDelete.Enabled := False;
            Form1.bProductsDelete.Enabled := False;

            frmClient.bContactDelete.Enabled := False;
            frmClient.bEventDelete.Enabled := False;
            frmClient.bDealDelete.Enabled := False;
            frmClient.bContractDelete.Enabled := False;
            frmClient.bOrderDelete.Enabled := False;
            frmClient.bDeleteOrderProduct.Enabled := False;
            frmClient.bDeleteInvoice.Enabled := False;
            frmClient.bPaymentDelete.Enabled := False;

            frmContract.bServiceDelete.Enabled := False;
            frmContract.bInvoiceDelete.Enabled := False;
            frmContract.bWorkDelete.Enabled := False;
            frmContract.bDocumentDelete.Enabled := False;
            frmContract.bPaymentDelete.Enabled := False;

            frmDeal.bContractDelete.Enabled := False;
            frmInvoice.bPaymentDelete.Enabled := False;
            frmInvoice.bProductDelete.Enabled := False;
            frmOrder.bProductDelete.Enabled := False;
        end;

    end;
end;




procedure frmLogin_bLogin_OnClick (Sender: TObject; var Cancel: boolean);
var
   s: string;
begin
     // disabled


     // SQL query for check user and password
     if frmLogin.edPassword.sqlValue <> 'NULL' then
         s := SQLExecute('SELECT count(id) FROM User WHERE (id = ' + frmLogin.cbLogin.sqlValue + ') AND (password = ' + frmLogin.edPassword.sqlValue + ');')
     else
         s := SQLExecute('SELECT count(id) FROM User WHERE (id = ' + frmLogin.cbLogin.sqlValue + ') AND (password IS NULL);');

     // if SQL query found login and password
     if (s <> '0') and (s<>'') then
     begin
          idUser := frmLogin.cbLogin.dbItemID;
          frmLogin.Hide; // close login form
          ApplyPrivilege(idUser);
          Form1.Caption := 'Учет (пользователь: ' + frmLogin.cbLogin.Text+')';
          Form1.Show;

          If SQLExecute('SELECT COUNT(*) FROM Client') > 3 then
          begin
              if not isReg then frmReg.ShowModal;
          end;

     end else MessageDlg('Неверный пароль.', mtError, mbOk, 0);
end;

procedure frmLogin_OnShow (Sender: TObject; Action: string);
begin
     frmLogin.mniFile.Visible := False;
     frmLogin.mniOptions.Visible := False;
     frmLogin.mniAbout.Visible := False;

     if SQLExecute('SELECT count(id) FROM User') = '0' then
     begin
         SQLExecute('INSERT INTO User (UserName, password, privAdmin) VALUES ("admin", NULL, 1);');
         UpdateDatabase('User');
     end;
end;

procedure frmContact_OnShow (Sender: TObject; Action: string);
begin
    if frmContact.CalledForm = frmClient then
    begin
        // убираем комбо, внешний ключ запишется автоматически
        frmContact.cbClient.Visible := False;
        frmContact.lbClient.Visible := False;
        frmContact.cbClient.dbForeignKey := '';
    end else
    if frmContact.CalledForm = Form1 then
    begin
        // показываем комбо с клиентами
        frmContact.cbClient.Visible := True;
        frmContact.lbClient.Visible := True;
    end;
end;
procedure frmContact_OnClose (Sender: TObject; Action: string);
begin
    frmContact.cbClient.dbForeignKey := 'Contact.id_Client';
end;


procedure frmEvent_OnShow (Sender: TObject; Action: string);
begin
    if frmEvent.CalledForm = frmClient then
    begin
        // убираем комбо, внешний ключ запишется автоматически
        frmEvent.cbClient.Visible := False;
        frmEvent.lbClient.Visible := False;
        frmEvent.cbClient.dbForeignKey := '';
    end else
    if frmEvent.CalledForm = Form1 then
    begin
        // показываем комбо с клиентами
        frmEvent.cbClient.Visible := True;
        frmEvent.lbClient.Visible := True;
    end;
end;
procedure frmEvent_OnClose (Sender: TObject; Action: string);
begin
    frmEvent.cbClient.dbForeignKey := 'Event.id_Client';
end;



procedure frmDeal_OnShow (Sender: TObject; Action: string);
begin
    if frmDeal.CalledForm = frmClient then
    begin
        // убираем комбо, внешний ключ запишется автоматически
        frmDeal.cbClient.Visible := False;
        frmDeal.lbClient.Visible := False;
        frmDeal.cbClient.dbForeignKey := '';
    end else
    if frmDeal.CalledForm = Form1 then
    begin
        // показываем комбо с клиентами
        frmDeal.cbClient.Visible := True;
        frmDeal.lbClient.Visible := True;
    end;
end;
procedure frmDeal_OnClose (Sender: TObject; Action: string);
begin
    frmDeal.cbClient.dbForeignKey := 'Deal.id_Client';
end;



procedure frmContract_OnShow (Sender: TObject; Action: string);
begin
    frmContract.cbClient.Enabled := False;
    frmContract.lbClient.Enabled := False;

    if frmContract.CalledForm = frmDeal then
    begin
        // подставляем клиента в комбо, т.к. используется промежуточная форма
        frmContract.cbClient.Visible := True;
        frmContract.lbClient.Visible := True;
        frmContract.cbClient.dbItemID := SQLExecute('SELECT id_Client FROM Deal WHERE id='+ IntToStr(frmDeal.bSaveDeal.dbGeneralTableId));
    end else
    if frmContract.CalledForm = frmClient then
    begin
        // убираем комбо, внешний ключ запишется автоматически
        frmContract.cbClient.Visible := False;
        frmContract.lbClient.Visible := False;
        frmContract.cbClient.dbForeignKey := '';
    end else
    if frmContract.CalledForm = Form1 then
    begin
        // позволяем редактировать комбо при создании новой записи
        frmContract.cbClient.Visible := True;
        frmContract.lbClient.Visible := True;

        if Action = 'NewRecord' then // можно менять клиента только для новой записи
        begin
            frmContract.cbClient.Enabled := True;
            frmContract.lbClient.Enabled := True;
        end;
    end;
end;
procedure frmContract_OnClose (Sender: TObject; Action: string);
begin
    frmContract.cbClient.dbForeignKey := 'Contract.id_Client';
end;





procedure frmInvoice_OnShow (Sender: TObject; Action: string);
var
    id: integer;
begin
    frmInvoice.cbInvoiceContract.Enabled := True;
    frmInvoice.lbContract.Enabled := True;

    frmInvoice.cbClient.Enabled := False;
    frmInvoice.lbClient.Enabled := False;
    id := frmInvoice.cbInvoiceContract.dbItemID;

    if frmInvoice.CalledForm = frmContract then
    begin
        // подставляем клиента в комбо, т.к. используется промежуточная форма
        frmInvoice.cbClient.Visible := True;
        frmInvoice.lbClient.Visible := True;
        frmInvoice.cbClient.dbItemID := SQLExecute('SELECT id_Client FROM Contract WHERE id='+ IntToStr(frmContract.bSaveContract.dbGeneralTableId));

        // загружаем контракты, которые принадлежат текущему клиенту
        frmInvoice.cbInvoiceContract.dbSQLExecute(ReturnContractNumbers+' WHERE Contract.id_Client='+frmInvoice.cbClient.sqlValue );
        frmInvoice.cbInvoiceContract.dbItemID := id;
    end else
    if frmInvoice.CalledForm = frmClient then
    begin
        // убираем комбо, внешний ключ запишется автоматически
        frmInvoice.cbClient.Visible := False;
        frmInvoice.lbClient.Visible := False;
        frmInvoice.cbClient.dbForeignKey := '';

        // загружаем контракты, которые принадлежат текущему клиенту
        frmInvoice.cbInvoiceContract.dbSQLExecute(ReturnContractNumbers + ' WHERE Contract.id_Client='+ IntToStr(frmClient.bClientSave.dbGeneralTableId) );
        frmInvoice.cbInvoiceContract.dbItemID := id;
    end else
    if frmInvoice.CalledForm = Form1 then
    begin
        frmInvoice.cbClient.Visible := True;
        frmInvoice.lbClient.Visible := True;

        if Action = 'NewRecord' then // можно менять клиента только для новой записи
        begin
            frmInvoice.cbClient.Enabled := True;
            frmInvoice.lbClient.Enabled := True;
        end;

        // загружаем все контракты и блокируем компонент, иначе смогут выбрать контракт, который не принадлежит выбранному клиенту
        frmInvoice.cbInvoiceContract.dbSQLExecute(ReturnContractNumbers);
        frmInvoice.cbInvoiceContract.dbItemID := id;
        frmInvoice.cbInvoiceContract.Enabled := False;
        frmInvoice.lbContract.Enabled := False;
    end;

end;
procedure frmInvoice_OnClose (Sender: TObject; Action: string);
begin
    frmInvoice.cbClient.dbForeignKey := 'Invoice.id_Client';
end;



procedure frmPayment_OnShow (Sender: TObject; Action: string);
begin
    frmPayment.cbClient.Enabled := False;
    frmPayment.lbClient.Enabled := False;

    if frmPayment.CalledForm = frmContract then
    begin
        // подставляем клиента в комбо, т.к. используется промежуточная форма
        frmPayment.cbClient.Visible := True;
        frmPayment.lbClient.Visible := True;
        frmPayment.cbClient.dbItemID := SQLExecute('SELECT id_Client FROM Contract WHERE id='+ IntToStr(frmContract.bSaveContract.dbGeneralTableId));
    end else
    if frmPayment.CalledForm = frmInvoice then
    begin
        // подставляем клиента в комбо, т.к. используется промежуточная форма
        frmPayment.cbClient.Visible := True;
        frmPayment.lbClient.Visible := True;
        frmPayment.cbClient.dbItemID := SQLExecute('SELECT id_Client FROM Invoice WHERE id='+ IntToStr(frmInvoice.bSaveInvoice.dbGeneralTableId));
    end else
    if frmPayment.CalledForm = frmClient then
    begin
        // убираем комбо, внешний ключ запишется автоматически
        frmContract.cbClient.Visible := False;
        frmContract.lbClient.Visible := False;
        frmContract.cbClient.dbForeignKey := '';
    end else
    if frmPayment.CalledForm = Form1 then
    begin
        frmPayment.cbClient.Visible := True;
        frmPayment.lbClient.Visible := True;

        if Action = 'NewRecord' then // можно менять клиента только для новой записи
        begin
            frmPayment.cbClient.Enabled := True;
            frmPayment.lbClient.Enabled := True;
        end;
    end;

end;
procedure frmPayment_OnClose (Sender: TObject; Action: string);
begin
    frmPayment.cbClient.dbForeignKey := 'Payment.id_Client';
end;



procedure frmOrder_OnShow (Sender: TObject; Action: string);
begin
    if frmOrder.CalledForm = frmClient then
    begin
        // убираем комбо, внешний ключ запишется автоматически
        frmOrder.cbClient.Visible := False;
        frmOrder.lbClient.Visible := False;
        frmOrder.cbClient.dbForeignKey := '';
    end else
    if frmOrder.CalledForm = Form1 then
    begin
        // показываем комбо с клиентами
        frmOrder.cbClient.Visible := True;
        frmOrder.lbClient.Visible := True;

        // можно менять клиента только для новой записи
        frmOrder.cbClient.Enabled :=  Action = 'NewRecord';
        frmOrder.lbClient.Enabled :=  Action = 'NewRecord';
    end;
end;
procedure frmOrder_OnClose (Sender: TObject; Action: string);
begin
    frmOrder.cbClient.dbForeignKey := 'Order.id_Client';
end;



procedure frmOrderProduct_OnShow (Sender: TObject; Action: string);
begin
    if frmOrderProduct.CalledForm = frmClient then
    begin
        // убираем комбо, внешний ключ запишется автоматически
        frmOrderProduct.cbClient.Visible := False;
        frmOrderProduct.lbClient.Visible := False;
        frmOrderProduct.cbClient.dbForeignKey := '';
    end else
    if frmOrderProduct.CalledForm = Form1 then
    begin
        // показываем комбо с клиентами
        frmOrderProduct.cbClient.Visible := True;
        frmOrderProduct.lbClient.Visible := True;
    end;
end;
procedure frmOrderProduct_OnClose (Sender: TObject; Action: string);
begin
    frmOrderProduct.cbClient.dbForeignKey := 'OrderProduct.id_Client';
end;










procedure frmOrderProduct_cbProduct_OnCloseUp (Sender: TObject);
begin
    frmOrderProduct.edCost.Value := SQLExecute('SELECT Cost FROM Product WHERE id='+frmOrderProduct.cbProduct.sqlValue);
end;

procedure frmOrderProduct_CaclulateCostProduct (Sender: TObject);
begin
    frmOrderProduct.edTotal.Value := frmOrderProduct.edCost.Value * frmOrderProduct.edQuantity.Value;
end;



procedure frmInvoiceProduct_CaclulateCostProduct (Sender: TObject);
begin
    frmInvoiceProduct.edTotal.Value := frmInvoiceProduct.edCost.Value * frmInvoiceProduct.edQuantity.Value;
    frmInvoiceProduct.edVatValue.Value := frmInvoiceProduct.edTotal.Value * (frmInvoiceProduct.edVat.Value / 100);
    frmInvoiceProduct.edTotalVat.Value := frmInvoiceProduct.edTotal.Value + frmInvoiceProduct.edVatValue.Value;
end;

procedure frmInvoiceProduct_cbProduct_OnCloseUp (Sender: TObject);
begin
    frmInvoiceProduct.edCost.Value := SQLExecute('SELECT Cost FROM Product WHERE id='+frmInvoiceProduct.cbProduct.sqlValue);
end;




procedure frmService_cbServiceProduct_OnCloseUp (Sender: TObject);
begin
    frmService.edServiceCost.Value := SQLExecute('SELECT Cost FROM Product WHERE id='+frmService.cbServiceProduct.sqlValue);
end;

procedure frmClient_gridOrder_OnChange (Sender: TObject);
begin
   if frmClient.gridOrder.Columns[4] is TNxNumberColumn then
    begin
        TNxNumberColumn(frmClient.gridOrder.Columns[4]).FormatMask := '#,##0.00';
        TNxNumberColumn(frmClient.gridOrder.Columns[4]).Footer.FormatMask := '#,##0.00';
    end;
end;                     

procedure frmClient_gridOrdered_OnChange (Sender: TObject);
begin
   if frmClient.gridOrdered.Columns[3] is TNxNumberColumn then
    begin
        TNxNumberColumn(frmClient.gridOrdered.Columns[3]).FormatMask := '#,##0.00';
        TNxNumberColumn(frmClient.gridOrdered.Columns[3]).Footer.FormatMask := '#,##0.00';
    end;
end;

procedure frmOrder_gridOrderProduct_OnChange (Sender: TObject);
begin
   if frmOrder.gridOrderProduct.Columns[3] is TNxNumberColumn then
    begin
        TNxNumberColumn(frmOrder.gridOrderProduct.Columns[3]).FormatMask := '#,##0.00';
        TNxNumberColumn(frmOrder.gridOrderProduct.Columns[3]).Footer.FormatMask := '#,##0.00';
    end;
end;

procedure frmInvoice_gridProducInvoice_OnChange (Sender: TObject);
begin
   if frmInvoice.gridProducInvoice.Columns[3] is TNxNumberColumn then
    begin
        TNxNumberColumn(frmInvoice.gridProducInvoice.Columns[4]).FormatMask := '#,##0.00';
        TNxNumberColumn(frmInvoice.gridProducInvoice.Columns[4]).Footer.FormatMask := '#,##0.00';
    end;

   if frmInvoice.gridProducInvoice.Columns[5] is TNxNumberColumn then
    begin
        TNxNumberColumn(frmInvoice.gridProducInvoice.Columns[6]).FormatMask := '#,##0.00';
        TNxNumberColumn(frmInvoice.gridProducInvoice.Columns[6]).Footer.FormatMask := '#,##0.00';
    end;

   if frmInvoice.gridProducInvoice.Columns[6] is TNxNumberColumn then
    begin
        TNxNumberColumn(frmInvoice.gridProducInvoice.Columns[7]).FormatMask := '#,##0.00';
        TNxNumberColumn(frmInvoice.gridProducInvoice.Columns[7]).Footer.FormatMask := '#,##0.00';
    end;
end;



procedure Form1_OnShow (Sender: TObject; Action: string);
begin

    frmInvoice.cbInvoiceContract.dbSQLExecute(ReturnContractNumbers);

    If SQLExecute('SELECT COUNT(*) FROM Sex') = 0 then
    begin
        SQLExecute('INSERT INTO Sex (Sex) VALUES (''Муж.''), (''Жен.'')');
        UpdateDatabase('Sex');
    end;

    If SQLExecute('SELECT COUNT(*) FROM Unit') = 0 then
    begin
        SQLExecute('INSERT INTO Unit (UnitName) VALUES (''шт''), (''кг'')');
        UpdateDatabase('Sex');
    end;

    If SQLExecute('SELECT COUNT(*) FROM Seller') = 0 then
    begin
        SQLExecute('INSERT INTO Seller (id, Name) VALUES (1, '+'"Моя организация"'+')');
    end;



    If SQLExecute('SELECT COUNT(*) FROM ClientStatus') = 0 then
    begin
        SQLExecute('INSERT INTO ClientStatus (ClientStatus) VALUES (''Активный''), (''Неактивный'')');
        UpdateDatabase('ClientStatus');
    end;

    If SQLExecute('SELECT COUNT(*) FROM ClientType') = 0 then
    begin
        SQLExecute('INSERT INTO ClientType (ClientType) VALUES (''Физ. лицо''), (''Юр. лицо'')');
        UpdateDatabase('ClientType');
    end;

    If SQLExecute('SELECT COUNT(*) FROM ClientSource') = 0 then
    begin
        SQLExecute('INSERT INTO ClientSource (ClientSource) VALUES (''Сайт''), (''Входящий звонок''), (''Исходящий звонок''), (''Существующий клиент''), (''Социальные сети''), (''Конференция'')');
        UpdateDatabase('ClientSource');
    end;  //'

    If SQLExecute('SELECT COUNT(*) FROM Loyalty') = 0 then
    begin
        SQLExecute('INSERT INTO Loyalty (Loyalty) VALUES (''Горячий''), (''Теплый''), (''Холодный'')');
        UpdateDatabase('Loyalty');
    end;

    If SQLExecute('SELECT COUNT(*) FROM DealType') = 0 then
    begin
        SQLExecute('INSERT INTO DealType (DealType) VALUES (''Купля-Продажа''), (''Поставка''), (''Аренда'')');
        UpdateDatabase('DealType');
    end;

    If SQLExecute('SELECT COUNT(*) FROM DealStage') = 0 then
    begin
        SQLExecute('INSERT INTO DealStage (DealStage) VALUES (''Разведка''), (''Анализ нужд''), (''Отправлено КП''), (''Отправлен договор''), (''Успех''), (''Отказ'')');
        UpdateDatabase('DealStage');
    end;

    If SQLExecute('SELECT COUNT(*) FROM ContractStatus') = 0 then
    begin
        SQLExecute('INSERT INTO ContractStatus (ContractStatus) VALUES (''Активен''), (''Неактивен''), (''Закрыт''), (''Приостановлен'')');
        UpdateDatabase('ContractStatus');
    end;

    If SQLExecute('SELECT COUNT(*) FROM DocumentType') = 0 then
    begin
        SQLExecute('INSERT INTO DocumentType (TypeName) VALUES (''Акт выполненных работ''), (''Приложение''), (''Рабочий проект''), (''Чертеж''), (''Техзадание'')');
        UpdateDatabase('DocumentType');
    end;

    If SQLExecute('SELECT COUNT(*) FROM EventStatus') = 0 then
    begin
        SQLExecute('INSERT INTO EventStatus (StatusName) VALUES (''Запланировано''), (''Состоялось''), (''Не состоялось'')');
        UpdateDatabase('EventStatus');
    end;

    If SQLExecute('SELECT COUNT(*) FROM EventPriority') = 0 then
    begin
        SQLExecute('INSERT INTO EventPriority (PriorityName) VALUES (''Высокий''), (''Средний''), (''Низкий'')');
        UpdateDatabase('EventPriority');
    end;

    If SQLExecute('SELECT COUNT(*) FROM EventResult') = 0 then
    begin
        SQLExecute('INSERT INTO EventResult (ResultName) VALUES (''Хорошо''), (''Нейтрально''), (''Плохо'')');
        UpdateDatabase('EventResult');
    end;

    If SQLExecute('SELECT COUNT(*) FROM EventCategory') = 0 then
    begin
        SQLExecute('INSERT INTO EventCategory (CategoryName) VALUES (''Звонок''), (''E-mail''), (''Встреча''), (''Совещание''), (''Задача'')');
        UpdateDatabase('EventCategory');
    end;

    If SQLExecute('SELECT COUNT(*) FROM InvoiceType') = 0 then
    begin
        SQLExecute('INSERT INTO InvoiceType (TypeName) VALUES (''Безнал''), (''Нал'')');
        UpdateDatabase('InvoiceType');
    end;

    If SQLExecute('SELECT COUNT(*) FROM InvoiceStatus') = 0 then
    begin
        SQLExecute('INSERT INTO InvoiceStatus (StatusName) VALUES (''Выставлен''), (''Оплачен''), (''Оплачен частично''), (''Отменен'')');
        UpdateDatabase('InvoiceStatus');
    end;

    If SQLExecute('SELECT COUNT(*) FROM OrderStatus') = 0 then
    begin
        SQLExecute('INSERT INTO OrderStatus (StatusName) VALUES (''Принят''), (''Выполнен''), (''Отменен'')');
        UpdateDatabase('OrderStatus');
    end;

    If SQLExecute('SELECT COUNT(*) FROM OrderType') = 0 then
    begin
        SQLExecute('INSERT INTO OrderType (TypeName) VALUES (''Визитки''), (''Календари''), (''Сувениры'')');
        UpdateDatabase('OrderType');
    end;

    If SQLExecute('SELECT COUNT(*) FROM PaymentSystem') = 0 then
    begin
        SQLExecute('INSERT INTO PaymentSystem (SystemName) VALUES (''Сбербанк''), (''Касса в офисе''), (''WebMoney''), (''Яндекс-Деньги'')');
        UpdateDatabase('PaymentSystem');
    end;

    If SQLExecute('SELECT COUNT(*) FROM PaymentStatus') = 0 then
    begin
        SQLExecute('INSERT INTO PaymentStatus (StatusName) VALUES (''Предоплата''), (''Оплата получена''), (''Оплата подтверждена''), (''Обещанный платеж''), (''Платеж отменен'')');
        UpdateDatabase('PaymentStatus');
    end;

    If SQLExecute('SELECT COUNT(*) FROM ProductType') = 0 then
    begin
        SQLExecute('INSERT INTO ProductType (TypeName) VALUES (''Товар''), (''Услуга разовая''), (''Услуга периодическая'')');
        UpdateDatabase('ProductType');
    end;

    If SQLExecute('SELECT COUNT(*) FROM ServiceStatus') = 0 then
    begin
        SQLExecute('INSERT INTO ServiceStatus (StatusName) VALUES (''Оказывается''), (''Не оказывается'')');
        UpdateDatabase('ServiceStatus');
    end;

    If SQLExecute('SELECT COUNT(*) FROM WorkType') = 0 then
    begin
        SQLExecute('INSERT INTO WorkType (TypeName) VALUES (''Ремонт''), (''Профилактика''), (''Настройка'')');
        UpdateDatabase('WorkType');
    end;

    If SQLExecute('SELECT COUNT(*) FROM WorkStatus') = 0 then
    begin
        SQLExecute('INSERT INTO WorkStatus (StatusName) VALUES (''Выполняется''), (''Выполнено''), (''Запланировано'')');
        UpdateDatabase('WorkStatus');
    end; //'

    If SQLExecute('SELECT COUNT(*) FROM Unit') = 0 then
    begin
        SQLExecute('INSERT INTO Unit (UnitName) VALUES (''шт''), (''кг'')');
        UpdateDatabase('Unit');
    end;

    Form1.bClientSearch.Click;
    Form1.bContactSearch.Click;
    Form1.bEventSearch.Click;
    Form1.bDealSearch.Click;
    Form1.bContractSearch.Click;
    Form1.bInvoiceSearch.Click;
    Form1.bPaymentSearch.Click;
    Form1.bOrderSearch.Click;
    Form1.bOrderedSearch.Click;
    Form1.bProductSearch.Click;

    Init;
end;


function ReturnContractNumbers: string;
begin  // чтобы работало на SQLite и MySQL
    if frmLogin.MySQLConnection.Connected then
    result := 'SELECT CONCAT(''№ '', record_count, '' от '', DATE_FORMAT(Contract.DateContract, ''%d.%m.%Y'')), id FROM Contract'
    else result := 'SELECT ''№'' || Contract.record_count || '' от '' || strftime(''%d.%m.%Y'', Contract.DateContract), id FROM Contract';
end;


procedure Form1_lbDevelop_OnClick (Sender: TObject);
begin
     OpenURL('http://myvisualdatabase.com/develop_ru.html');
end;

procedure Form1_OnClose (Sender: TObject; Action: string);
begin
    frmLogin.Close;
end;

procedure SubitemSettingsClick (Sender: TObject);
begin
     frmOptionsdbCore.ShowModal;
end;

procedure SubitemCloseClick (Sender: TObject);
begin
     frmLogin.Close;
end;

procedure ItemOrderClick (Sender: TObject);
begin
     OpenURL('http://myvisualdatabase.com/develop_ru.html');
end;

procedure ItemAboutClick (Sender: TObject);
begin
     frmAbout.ShowModal;
end;


procedure Init;
var
   MainMenu: TMainMenu;
   ItemFile: TMenuItem;
       SubitemSettings: TMenuItem;
       SubitemClose: TMenuItem;
   ItemOrder: TMenuItem;
   ItemAbout: TMenuItem;
begin
   ItemFile := TMenuItem.Create (Form1);
   ItemFile.Caption := 'Файл';
       SubitemClose := TMenuItem.Create (Form1);
       SubitemClose.Caption := 'Закрыть';
       SubitemClose.OnClick := @SubitemCloseClick;

       SubitemClose := TMenuItem.Create (Form1);
       SubitemClose.Caption := 'Настройка';
       SubitemClose.OnClick := @SubitemSettingsClick;


   ItemOrder := TMenuItem.Create (Form1);
   ItemOrder.Caption := 'Доработать программу';
   ItemOrder.OnClick := @ItemOrderClick;

   ItemAbout := TMenuItem.Create (Form1);
   ItemAbout.Caption := 'О Программе...';
   ItemAbout.OnClick := @ItemAboutClick;


   MainMenu := TMainMenu.Create(Form1); // Create MainMenu on Form2
   MainMenu.Items.Add(ItemFile);
   MainMenu.Items.Add(ItemOrder);
   MainMenu.Items.Add(ItemAbout);
   ItemFile.Add(SubitemClose);




    //CheckReg;
    frmReg.FormStyle := fsStayOnTop;
end;


begin


end.
